#include "B4RDefines.h"
#include "rAXP192.h"

namespace B4R
{

    AXP192 axp192;

    void B4RAXP192::begin(bool disableLDO2, bool disableLDO3, bool disableRTC, bool disableDCDC1, bool disableDCDC3)
    {
       axp192.begin(disableLDO2, disableLDO3, disableRTC, disableDCDC1, disableDCDC3);
    }

    void B4RAXP192::ScreenBreath(byte brightness)
    {
       axp192.ScreenBreath(brightness);
    }

    bool B4RAXP192::GetBatState()
    {
       return axp192.GetBatState();
    }

    byte B4RAXP192::GetInputPowerStatus()
    {
       return axp192.GetInputPowerStatus();
    }

    byte B4RAXP192::GetBatteryChargingStatus()
    {
       return axp192.GetBatteryChargingStatus();
    }

    void B4RAXP192::EnableCoulombcounter()
    {
       axp192.EnableCoulombcounter();
    }

    void B4RAXP192::DisableCoulombcounter()
    {
       axp192.DisableCoulombcounter();
    }

    void B4RAXP192::StopCoulombcounter()
    {
       axp192.StopCoulombcounter();
    }

    void B4RAXP192::ClearCoulombcounter()
    {
       axp192.ClearCoulombcounter();
    }

    ulong B4RAXP192::GetCoulombchargeData()
    {
       return axp192.GetCoulombchargeData();
    }

    ulong B4RAXP192::GetCoulombdischargeData()
    {
       return axp192.GetCoulombdischargeData();
    }

    double B4RAXP192::GetCoulombData()
    {
       return axp192.GetCoulombData();
    }

    uint B4RAXP192::GetVbatData()
    {
       return axp192.GetVbatData();
    }

    uint B4RAXP192::GetIchargeData()
    {
       return axp192.GetIchargeData();
    }

    uint B4RAXP192::GetIdischargeData()
    {
       return axp192.GetIdischargeData();
    }

    uint B4RAXP192::GetTempData()
    {
       return axp192.GetTempData();
    }

    ulong B4RAXP192::GetPowerbatData()
    {
       return axp192.GetPowerbatData();
    }

    uint B4RAXP192::GetVinData()
    {
       return axp192.GetVinData();
    }

    uint B4RAXP192::GetIinData()
    {
       return axp192.GetIinData();
    }

    uint B4RAXP192::GetVusbinData()
    {
       return axp192.GetVusbinData();
    }

    uint B4RAXP192::GetIusbinData()
    {
       return axp192.GetIusbinData();
    }

    uint B4RAXP192::GetVapsData()
    {
       return axp192.GetVapsData();
    }

    byte B4RAXP192::GetBtnPress()
    {
       return axp192.GetBtnPress();
    }

    void B4RAXP192::SetSleep()
    {
       axp192.SetSleep();
    }

    void B4RAXP192::DeepSleep(ulong time_in_us)
    {
       axp192.DeepSleep(time_in_us);
    }

    void B4RAXP192::LightSleep(ulong time_in_us)
    {
       axp192.LightSleep(64_t time_in_us);
    }

    byte B4RAXP192::GetWarningLeve()
    {
       return axp192.GetWarningLeve();
    }

    void B4RAXP192::SetChargeCurrent(byte current)
    {
       axp192.SetChargeCurrent(current);
    }

    double B4RAXP192::GetBatVoltage()
    {
       return axp192.GetBatVoltage();
    }

    double B4RAXP192::GetBatCurrent()
    {
       return axp192.GetBatCurrent();
    }

    double B4RAXP192::GetVinVoltage()
    {
       return axp192.GetVinVoltage();
    }

    double B4RAXP192::GetVinCurrent()
    {
       return axp192.GetVinCurrent();
    }

    double B4RAXP192::GetVBusVoltage()
    {
       return axp192.GetVBusVoltage();
    }

    double B4RAXP192::GetVBusCurrent()
    {
       return axp192.GetVBusCurrent();
    }

    double B4RAXP192::GetTempInAXP192()
    {
       return axp192.GetTempInAXP192();
    }

    double B4RAXP192::GetBatPower()
    {
       return axp192.GetBatPower();
    }

    double B4RAXP192::GetBatChargeCurrent()
    {
       return axp192.GetBatChargeCurrent();
    }

    double B4RAXP192::GetAPSVoltage()
    {
       return axp192.GetAPSVoltage();
    }

    double B4RAXP192::GetBatCoulombInput()
    {
       return axp192.GetBatCoulombInput();
    }

    double B4RAXP192::GetBatCoulombOut()
    {
       return axp192.GetBatCoulombOut();
    }

    byte B4RAXP192::GetWarningLevel()
    {
       return axp192.GetWarningLevel();
    }

    void B4RAXP192::SetCoulombClear()
    {
       axp192.SetCoulombClear();
    }

    void B4RAXP192::SetLDO2(bool State)
    {
       axp192.SetLDO2(State);
    }

    void B4RAXP192::SetLDO3(bool State)
    {
       axp192.SetLDO3(State);
    }

    void B4RAXP192::SetAdcState(bool State)
    {
       axp192.SetAdcState(State);
    }

    void B4RAXP192::PowerOff()
    {
       axp192.PowerOff();
    }

    void B4RAXP192::Read6BytesStorage(ArrayByte* bufPtr)
    {
       axp192.Read6BytesStorage((byte*)bufPtr->data);
    }

    void B4RAXP192::Write6BytesStorage(ArrayByte* bufPtr)
    {
       axp192.Write6BytesStorage((byte*)bufPtr->data);
    }

}


