#pragma once
#include "B4RDefines.h"
#include "AXP192.h"

    //~Event: 
    //~Version: 1.0 
    //~Author - 
    //~Libray from Arduino

namespace B4R {
    //~shortname:AXP192 
    class B4RAXP192 
    {
        private:
            AXP192 axp192;
        public:
            void begin(bool disableLDO2, bool disableLDO3, bool disableRTC, bool disableDCDC1, bool disableDCDC3);
            void ScreenBreath(byte brightness);
            bool GetBatState();
            byte GetInputPowerStatus();
            byte GetBatteryChargingStatus();
            void EnableCoulombcounter();
            void DisableCoulombcounter();
            void StopCoulombcounter();
            void ClearCoulombcounter();
            ulong GetCoulombchargeData();
            ulong GetCoulombdischargeData();
            double GetCoulombData();
            uint GetVbatData();
            uint GetIchargeData();
            uint GetIdischargeData();
            uint GetTempData();
            ulong GetPowerbatData();
            uint GetVinData();
            uint GetIinData();
            uint GetVusbinData();
            uint GetIusbinData();
            uint GetVapsData();
            byte GetBtnPress();
            void SetSleep();
            void DeepSleep(ulong time_in_us);
            void LightSleep(ulong time_in_us);
            byte GetWarningLeve();
            void SetChargeCurrent(byte current);
            double GetBatVoltage();
            double GetBatCurrent();
            double GetVinVoltage();
            double GetVinCurrent();
            double GetVBusVoltage();
            double GetVBusCurrent();
            double GetTempInAXP192();
            double GetBatPower();
            double GetBatChargeCurrent();
            double GetAPSVoltage();
            double GetBatCoulombInput();
            double GetBatCoulombOut();
            byte GetWarningLevel();
            void SetCoulombClear();
            void SetLDO2(bool State);
            void SetLDO3(bool State);
            void SetAdcState(bool State);
            void PowerOff();
            void Read6BytesStorage(ArrayByte* bufPtr);
            void Write6BytesStorage(ArrayByte* bufPtr);
    };
}


